Attribute VB_Name = "TVCamera"
Option Explicit
Public CameraFPS As CameraFPS

Public Sub InitializeCamera()
  'New up a CameraFPS object.
  Set CameraFPS = New CameraFPS

  With CameraFPS
    'Set initial position and pass a reference to your landscape object.
    .Initialize 500, 500, 10, Landscape
    'Set gravity.
    .SetGravity -0.3
    'Set min max tilt
    .SetMaxMinTilt 60, -60
  End With
End Sub

Public Sub DoCamera()
 'Update the CameraFPS.
 CameraFPS.Update (tv.TimeElapsed)
  
 'Turn on/off the appropriate fog based on height of camera
  Dim camY As Single
  camY = CameraFPS.GetPosition.y
  'If Camera is underwater then water fog is turned on
  If camY < 50 Then
    SetWaterFog
    If Not (Windowed) Then
      GraphicEffect.AdvancedGamma 0.6, 0.7, 0.8
    End If
  Else
  'Changing this numbers to lower ones produces night scene
    SetLandFog
     GraphicEffect.AdvancedGamma 1, 1, 1
  End If
End Sub


