Attribute VB_Name = "TVInput"
Option Explicit

Public Inp As TrueVision3D.TVInputEngine

'Mouse
Private mouse_B1 As Boolean
Private mouse_B2 As Boolean
Private mouse_B3 As Boolean
Private absMx As Long
Private absMy As Long
Private MX As Long
Private MY As Long
Private Mscroll As Long
Private oldMscroll As Long
Private absB1 As Integer
Private absB2 As Integer
Private B1 As Integer
Private B2 As Integer
Private B3 As Integer

'Special keys
Private input_DOWN As Boolean
Private input_UP As Boolean
Private input_LEFT As Boolean
Private input_RIGHT As Boolean
Private input_ALT As Boolean
Private input_LBRACKET As Boolean
Private input_RBRACKET As Boolean
Private input_COMMA As Boolean
Private input_PERIOD As Boolean
Private input_COLON As Boolean
Private input_APOSTROPHE As Boolean
Private input_BACKSLASH As Boolean
Private input_CONTROL As Boolean
Private input_SHIFT As Boolean
Private input_INSERT As Boolean
Private input_DELETE As Boolean
Private input_HOME As Boolean
Private Input_END As Boolean
Private input_PGDN As Boolean
Private input_PGUP As Boolean
Private input_NUMPAD0 As Boolean
Private input_NUMPAD1 As Boolean
Private input_NUMPAD2 As Boolean
Private input_NUMPAD3 As Boolean
Private input_NUMPAD4 As Boolean
Private input_NUMPAD5 As Boolean
Private input_NUMPAD6 As Boolean
Private input_NUMPAD7 As Boolean
Private input_NUMPAD8 As Boolean
Private input_NUMPAD9 As Boolean
Private input_NUMPADCOMMA As Boolean
Private input_NUMPADENTER As Boolean
Private input_NUMPADEQUALS As Boolean
Private input_NUMPADMINUS As Boolean
Private input_NUMPADPERIOD As Boolean
Private input_NUMPADPLUS As Boolean
Private input_NUMPADSLASH As Boolean
Private input_NUMPADSTAR As Boolean
Private input_CAPSLOCK As Boolean
Private input_BACKSPACE As Boolean
Private input_ESCAPE As Boolean
Private input_PAUSE As Boolean
Private input_RETURN As Boolean
Private input_SPACE As Boolean
Private input_TAB As Boolean

'Function keys
Private input_F1 As Boolean
Private input_F2 As Boolean
Private input_F3 As Boolean
Private input_F4 As Boolean
Private input_F5 As Boolean
Private input_F6 As Boolean
Private input_F7 As Boolean
Private input_F8 As Boolean
Private input_F9 As Boolean
Private input_F10 As Boolean
Private input_F11 As Boolean
Private input_F12 As Boolean

'Numerix
Private input_1 As Boolean
Private input_2 As Boolean
Private input_3 As Boolean
Private input_4 As Boolean
Private input_5 As Boolean
Private input_6 As Boolean
Private input_7 As Boolean
Private input_8 As Boolean
Private input_9 As Boolean
Private input_0 As Boolean

'Alphabetix
Private input_A As Boolean
Private input_B As Boolean
Private input_C As Boolean
Private input_D As Boolean
Private input_E As Boolean
Private input_F As Boolean
Private input_G As Boolean
Private input_H As Boolean
Private input_I As Boolean
Private input_J As Boolean
Private input_K As Boolean
Private input_L As Boolean
Private input_M As Boolean
Private input_N As Boolean
Private input_O As Boolean
Private input_P As Boolean
Private input_Q As Boolean
Private input_R As Boolean
Private input_S As Boolean
Private input_T As Boolean
Private input_U As Boolean
Private input_V As Boolean
Private input_W As Boolean
Private input_X As Boolean
Private input_Y As Boolean
Private input_Z As Boolean

Public Sub InitializeInput()
  Set Inp = New TrueVision3D.TVInputEngine
End Sub

Public Sub DoInput()
  DoKeyboard
  DoMouse
End Sub

Private Sub DoKeyboard()

  If Inp.IsKeyPressed(TV_KEY_0) Then
    If input_0 = False Then
      input_0 = True
    End If
  Else
    input_0 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_1) Then
    If input_1 = False Then
      Scene.SetRenderMode (TV_LINE)
      input_1 = True
    End If
  Else
    input_1 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_2) Then
    If input_2 = False Then
      Scene.SetRenderMode (TV_POINT)
      input_2 = True
    End If
  Else
    input_2 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_3) Then
    If input_3 = False Then
      Scene.SetRenderMode (TV_SOLID)
      input_3 = True
    End If
  Else
    input_3 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_4) Then
    If input_4 = False Then
      input_4 = True
    End If
  Else
    input_4 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_5) Then
    If input_5 = False Then
      input_5 = True
    End If
  Else
    input_5 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_6) Then
    If input_6 = False Then
      input_6 = True
    End If
  Else
    input_6 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_7) Then
    If input_7 = False Then
      input_7 = True
    End If
  Else
    input_7 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_8) Then
    If input_8 = False Then
      input_8 = True
    End If
  Else
    input_8 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_9) Then
    If input_9 = False Then
      input_9 = True
    End If
  Else
    input_9 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F1) Then
    If input_F1 = False Then
      input_F1 = True
    End If
  Else
    input_F1 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F2) Then
    If input_F2 = False Then
      input_F2 = True
    End If
  Else
    input_F2 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F3) Then
    If input_F3 = False Then
      input_F3 = True
    End If
  Else
    input_F3 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F4) Then
    If input_F4 = False Then
      input_F4 = True
    End If
  Else
    input_F4 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F5) Then
    If input_F5 = False Then
      input_F5 = True
    End If
  Else
    input_F5 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F6) Then
    If input_F6 = False Then
      input_F6 = True
    End If
  Else
    input_F6 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F7) Then
    If input_F7 = False Then
      input_F7 = True
    End If
  Else
    input_F7 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F8) Then
    If input_F8 = False Then
      input_F8 = True
    End If
  Else
    input_F8 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F9) Then
    If input_F9 = False Then
      input_F9 = True
    End If
  Else
    input_F9 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F10) Then
    If input_F10 = False Then
      input_F10 = True
    End If
  Else
    input_F10 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F11) Then
    If input_F11 = False Then
      input_F11 = True
    End If
  Else
    input_F11 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F12) Then
    If input_F12 = False Then
      input_F12 = True
    End If
  Else
    input_F12 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_A) Then
    If input_A = False Then
      CameraFPS.MoveLeft
      'input_A = True
    End If
  Else
    input_A = False
  End If

  If Inp.IsKeyPressed(TV_KEY_B) Then
    If input_B = False Then
      CameraFPS.SetPosition3D 300, 200, 400
      'input_B = True
    End If
  Else
    input_B = False
  End If

  If Inp.IsKeyPressed(TV_KEY_C) Then
    If input_C = False Then
      input_C = True
    End If
  Else
    input_C = False
  End If

  If Inp.IsKeyPressed(TV_KEY_D) Then
    If input_D = False Then
      CameraFPS.MoveRight
      'input_D = True
    End If
  Else
    input_D = False
  End If

  If Inp.IsKeyPressed(TV_KEY_E) Then
    If input_E = False Then
      input_E = True
    End If
  Else
    input_E = False
  End If

  If Inp.IsKeyPressed(TV_KEY_F) Then
    If input_F = False Then
      input_F = True
    End If
  Else
    input_F = False
  End If

  If Inp.IsKeyPressed(TV_KEY_G) Then
    If input_G = False Then
      input_G = True
    End If
  Else
    input_G = False
  End If

  If Inp.IsKeyPressed(TV_KEY_H) Then
    If input_H = False Then
      input_H = True
    End If
  Else
    input_H = False
  End If

  If Inp.IsKeyPressed(TV_KEY_I) Then
    If input_I = False Then
      input_I = True
    End If
  Else
    input_I = False
  End If

  If Inp.IsKeyPressed(TV_KEY_J) Then
    If input_J = False Then
      input_J = True
    End If
  Else
    input_J = False
  End If

  If Inp.IsKeyPressed(TV_KEY_K) Then
    If input_K = False Then
      input_K = True
    End If
  Else
    input_K = False
  End If

  If Inp.IsKeyPressed(TV_KEY_L) Then
    If input_L = False Then
      input_L = True
    End If
  Else
    input_L = False
  End If

  If Inp.IsKeyPressed(TV_KEY_M) Then
    If input_M = False Then
      input_M = True
    End If
  Else
    input_M = False
  End If

  If Inp.IsKeyPressed(TV_KEY_N) Then
    If input_N = False Then
      input_N = True
    End If
  Else
    input_N = False
  End If

  If Inp.IsKeyPressed(TV_KEY_O) Then
    If input_O = False Then
      input_O = True
    End If
  Else
    input_O = False
  End If

  If Inp.IsKeyPressed(TV_KEY_P) Then
    If input_P = False Then
      input_P = True
    End If
  Else
    input_P = False
  End If

  If Inp.IsKeyPressed(TV_KEY_Q) Then
    If input_Q = False Then
      input_Q = True
    End If
  Else
    input_Q = False
  End If

  If Inp.IsKeyPressed(TV_KEY_R) Then
    If input_R = False Then
      'input_R = True
    End If
  Else
    'CameraFPS.Run = False
    input_R = False
  End If

  If Inp.IsKeyPressed(TV_KEY_S) Then
    If input_S = False Then
      CameraFPS.MoveBackward
      'input_S = True
    End If
  Else
    input_S = False
  End If

  If Inp.IsKeyPressed(TV_KEY_T) Then
    If input_T = False Then
      input_T = True
    End If
  Else
    input_T = False
  End If

  If Inp.IsKeyPressed(TV_KEY_U) Then
    If input_U = False Then
      input_U = True
    End If
  Else
    input_U = False
  End If

  If Inp.IsKeyPressed(TV_KEY_V) Then
    If input_V = False Then
      input_V = True
    End If
  Else
    input_V = False
  End If

  If Inp.IsKeyPressed(TV_KEY_W) Then
    If input_W = False Then
      CameraFPS.MoveForward
      'input_W = True
    End If
  Else
    input_W = False
  End If

  If Inp.IsKeyPressed(TV_KEY_X) Then
    If input_X = False Then
      input_X = True
    End If
  Else
    input_X = False
  End If

  If Inp.IsKeyPressed(TV_KEY_Y) Then
    If input_Y = False Then
      ReverseMouseY = Not (ReverseMouseY)
      input_Y = True
    End If
  Else
    input_Y = False
  End If

  If Inp.IsKeyPressed(TV_KEY_Z) Then
    If input_Z = False Then
      input_Z = True
    End If
  Else
    input_Z = False
  End If

  If Inp.IsKeyPressed(TV_KEY_DOWNARROW) Then
    If input_DOWN = False Then
      CameraFPS.MoveBackward
    End If
  Else
    input_DOWN = False
  End If

  If Inp.IsKeyPressed(TV_KEY_UPARROW) Then
    If input_UP = False Then
      CameraFPS.MoveForward
      End If
  Else
    input_UP = False
  End If

  If Inp.IsKeyPressed(TV_KEY_LEFTARROW) Then
    If input_LEFT = False Then
      CameraFPS.MoveLeft
    End If
  Else
    input_LEFT = False
  End If

  If Inp.IsKeyPressed(TV_KEY_RIGHTARROW) Then
    If input_RIGHT = False Then
      CameraFPS.MoveRight
    End If
  Else
    input_RIGHT = False
  End If

  If Inp.IsKeyPressed(TV_KEY_LEFTBRACKET) Then
    If input_LBRACKET = False Then
      input_LBRACKET = True
    End If
  Else
    input_LBRACKET = False
  End If

  If Inp.IsKeyPressed(TV_KEY_RIGHTBRACKET) Then
    If input_RBRACKET = False Then
      input_RBRACKET = True
    End If
  Else
    input_RBRACKET = False
  End If

  If Inp.IsKeyPressed(TV_KEY_COMMA) Then
    If input_COMMA = False Then
      input_COMMA = True
    End If
  Else
    input_COMMA = False
  End If

  If Inp.IsKeyPressed(TV_KEY_PERIOD) Then
    If input_PERIOD = False Then
      input_PERIOD = True
    End If
  Else
    input_PERIOD = False
  End If

  If Inp.IsKeyPressed(TV_KEY_COLON) Then
    If input_COLON = False Then
      input_COLON = True
    End If
  Else
    input_COLON = False
  End If

  If Inp.IsKeyPressed(TV_KEY_APOSTROPHE) Then
    If input_APOSTROPHE = False Then
      input_APOSTROPHE = True
    End If
  Else
    input_APOSTROPHE = False
  End If

  If Inp.IsKeyPressed(TV_KEY_BACKSLASH) Then
    If input_BACKSLASH = False Then
      input_BACKSLASH = True
    End If
  Else
    input_BACKSLASH = False
  End If

  If Inp.IsKeyPressed(TV_KEY_ALT_LEFT) Then
    If input_ALT = False Then
      input_ALT = True
    End If
  Else
    If Inp.IsKeyPressed(TV_KEY_ALT_RIGHT) Then
      If input_ALT = False Then
        input_ALT = True
      End If
    Else
      input_ALT = False
    End If
  End If

  If Inp.IsKeyPressed(TV_KEY_LEFTCONTROL) Then
    If input_CONTROL = False Then
      
      input_CONTROL = True
    End If
  Else
    If Inp.IsKeyPressed(TV_KEY_RCONTROL) Then
      If input_CONTROL = False Then
        input_CONTROL = True
        tv.ScreenShot ("c:\screenshot.bmp")
      End If
    Else
      input_CONTROL = False
    End If
  End If

  If Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Then
    If input_SHIFT = False Then
      'input_SHIFT = True
    End If
  Else
    If Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT) Then
      If input_SHIFT = False Then
         CameraFPS.Run = True
        'input_SHIFT = True
      End If
    Else
      CameraFPS.Run = False
      input_SHIFT = False
    End If
  End If

  If Inp.IsKeyPressed(TV_KEY_INSERT) Then
    If input_INSERT = False Then
      input_INSERT = True
    End If
  Else
    input_INSERT = False
  End If

  If Inp.IsKeyPressed(TV_KEY_DELETE) Then
    If input_DELETE = False Then
      input_DELETE = True
    End If
  Else
    input_DELETE = False
  End If

  If Inp.IsKeyPressed(TV_KEY_HOME) Then
    If input_HOME = False Then
      input_HOME = True
    End If
  Else
    input_HOME = False
  End If

  If Inp.IsKeyPressed(TV_KEY_END) Then
    If Input_END = False Then
      Input_END = True
    End If
  Else
    Input_END = False
  End If

  If Inp.IsKeyPressed(TV_KEY_PAGEDOWN) Then
    If input_PGDN = False Then
      CameraFPS.Lower
      'input_PGDN = True
    End If
  Else
    input_PGDN = False
  End If

  If Inp.IsKeyPressed(TV_KEY_PAGEUP) Then
    If input_PGUP = False Then
      CameraFPS.Raise
      'input_PGUP = True
    End If
  Else
    input_PGUP = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD0) Then
    If input_NUMPAD0 = False Then
      input_NUMPAD0 = True
    End If
  Else
    input_NUMPAD0 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD1) Then
    If input_NUMPAD1 = False Then
      input_NUMPAD1 = True
    End If
  Else
    input_NUMPAD1 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD2) Then
    If input_NUMPAD2 = False Then
      input_NUMPAD2 = True
    End If
  Else
    input_NUMPAD2 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD3) Then
    If input_NUMPAD3 = False Then
      input_NUMPAD3 = True
    End If
  Else
    input_NUMPAD3 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD4) Then
    If input_NUMPAD4 = False Then
      input_NUMPAD4 = True
    End If
  Else
    input_NUMPAD4 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD5) Then
    If input_NUMPAD5 = False Then
      input_NUMPAD5 = True
    End If
  Else
    input_NUMPAD5 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD6) Then
    If input_NUMPAD6 = False Then
      input_NUMPAD6 = True
    End If
  Else
    input_NUMPAD6 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD7) Then
    If input_NUMPAD7 = False Then
      input_NUMPAD7 = True
    End If
  Else
    input_NUMPAD7 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD8) Then
    If input_NUMPAD8 = False Then
      input_NUMPAD8 = True
    End If
  Else
    input_NUMPAD8 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPAD9) Then
    If input_NUMPAD9 = False Then
      input_NUMPAD9 = True
    End If
  Else
    input_NUMPAD9 = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADCOMMA) Then
    If input_NUMPADCOMMA = False Then
      input_NUMPADCOMMA = True
    End If
  Else
    input_NUMPADCOMMA = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADENTER) Then
    If input_NUMPADENTER = False Then
      input_NUMPADENTER = True
    End If
  Else
    input_NUMPADENTER = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADEQUALS) Then
    If input_NUMPADEQUALS = False Then
      input_NUMPADEQUALS = True
    End If
  Else
    input_NUMPADEQUALS = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADMINUS) Then
    If input_NUMPADMINUS = False Then
      input_NUMPADMINUS = True
    End If
  Else
    input_NUMPADMINUS = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADPERIOD) Then
    If input_NUMPADPERIOD = False Then
      input_NUMPADPERIOD = True
    End If
  Else
    input_NUMPADPERIOD = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADPLUS) Then
    If input_NUMPADPLUS = False Then
      input_NUMPADPLUS = True
    End If
  Else
    input_NUMPADPLUS = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADSLASH) Then
    If input_NUMPADSLASH = False Then
      input_NUMPADSLASH = True
    End If
  Else
    input_NUMPADSLASH = False
  End If

  If Inp.IsKeyPressed(TV_KEY_NUMPADSTAR) Then
    If input_NUMPADSTAR = False Then
      input_NUMPADSTAR = True
    End If
  Else
    input_NUMPADSTAR = False
  End If

  If Inp.IsKeyPressed(TV_KEY_CAPSLOCK) Then
    If input_CAPSLOCK = False Then
      input_CAPSLOCK = True
    End If
  Else
    input_CAPSLOCK = False
  End If

  If Inp.IsKeyPressed(TV_KEY_BACKSPACE) Then
    If input_BACKSPACE = False Then
      input_BACKSPACE = True
    End If
  Else
    input_BACKSPACE = False
  End If

  If Inp.IsKeyPressed(TV_KEY_ESCAPE) Then
    If input_ESCAPE = False Then
     EndGameLoop
    End If
  Else
    input_ESCAPE = False
  End If

  If Inp.IsKeyPressed(TV_KEY_PAUSE) Then
    If input_PAUSE = False Then
      'input_PAUSE = True
      GraphicEffect.FadeOut
    End If
  Else
    input_PAUSE = False
  End If

  If Inp.IsKeyPressed(TV_KEY_RETURN) Then
    If input_RETURN = False Then
      input_RETURN = True
    End If
  Else
    input_RETURN = False
  End If

  If Inp.IsKeyPressed(TV_KEY_SPACE) Then
    If input_SPACE = False Then
      CameraFPS.Jump 0.5
      'input_SPACE = True
    End If
  Else
    input_SPACE = False
  End If

  If Inp.IsKeyPressed(TV_KEY_TAB) Then
    If input_TAB = False Then
      input_TAB = True
    End If
  Else
    input_TAB = False
  End If

End Sub

Private Sub DoMouse()

  ' Save the mouse scroll value
  oldMscroll = Mscroll

  ' Get the mouse state with the both methods
  Inp.GetAbsMouseState absMx, absMy, absB1, absB2
  Inp.GetMouseState MX, MY, B1, B2, B3, Mscroll

  ' Mouse movement / position

  ' Mouse scroller
  If Mscroll > oldMscroll Then

  ElseIf Mscroll < oldMscroll Then

  End If

  ' Mouse B1
  If B1 <> 0 Then
    If mouse_B1 = False Then
      Mouse_B1_Click
      mouse_B1 = True
    End If
  Else
    mouse_B1 = False
  End If

  ' Mouse B2
  If B2 <> 0 Then
    If mouse_B2 = False Then
      Mouse_B2_Click
      mouse_B2 = True
    End If
  Else
    mouse_B2 = False
  End If

  ' Mouse B3
  If B3 <> 0 Then
    If mouse_B3 = False Then
      Mouse_B3_Click
      mouse_B3 = True
    End If
  Else
    mouse_B3 = False
  End If
  
  With CameraFPS
    If ReverseMouseY Then
      .TiltUpDown CSng(MY)
      .Rotate CSng(MX)
    Else
      .TiltUpDown CSng(-MY)
      .Rotate CSng(MX)
    End If
  End With

End Sub

Public Sub Mouse_B1_Click()


  If B1 <> 0 Then
    If mouse_B1 = False Then
      mouse_B1 = True
    End If
  Else
    mouse_B1 = False
  End If
End Sub

Public Sub Mouse_B2_Click()

End Sub

Public Sub Mouse_B3_Click()

End Sub

