Attribute VB_Name = "TVLandscape"
Public Landscape As TrueVision3D.TVLandscape
Public WaterHeight As Single
Public TextureFactory As TrueVision3D.TVTextureFactory

Public Sub InitializeLandscape()
  Set Landscape = New TrueVision3D.TVLandscape
  
  With Landscape
    'Set Height of landscape
    .SetFactorY 0.8
    'Create terrain
    .GenerateHugeTerrain "Landscape\map.jpg", TV_PRECISION_HIGH, 8, 8, 0, 0, True
    .SetTexture GetTex("Grass")
    .SetTextureScale 2, 2
    .ExpandTexture GetTex("Grass"), 0, 0, 1, 1
  End With
  InitializeWater
End Sub

Private Sub InitializeWater()
  With Landscape
  'Create water
    WaterHeight = 50
    .SetWaterTexture GetTex("water")
    .SetWaterColor 1, 1, 1, 1
    .SetWaterEffect True, 0.99, True, D3DBLEND_DESTCOLOR, D3DBLEND_SRCCOLOR, False
    .SetWaterTextureScale 5
    .SetWaterAltitude WaterHeight
    .SetWaterEnable True
  End With
End Sub

Public Sub DoLandscape()

End Sub

Private Sub DoWaterFog()
  If CameraFPS.GetPosition.y < WaterHeight Then
    SetWaterFog
  Else
    SetLandFog
  End If
End Sub
