Attribute VB_Name = "TVMesh"

 Public Function BuildStone(Name As String, Texture As Long, _
                                Radius As Single, Optional Slice As Long = 4, _
                                Optional Stack As Long = 4)
  Dim mMesh As New TrueVision3D.TVMesh
  Set mMesh = Scene.CreateMeshBuilder(Name)
  mMesh.CreateSphere Texture, Radius, Slice, Stack
  Randomize
  mMesh.SetRotation Rnd() * 100, Rnd() * 100, Rnd() * 110
   
  Set BuildStone = mMesh
End Function

Public Function BuildSphereMesh(Name As String, Texture As Long, _
                                Radius As Single, Optional Slice As Long = 4, _
                                Optional Stack As Long = 3)
  Dim mMesh As New TrueVision3D.TVMesh
  Set mMesh = Scene.CreateMeshBuilder(Name)
  mMesh.CreateSphere Texture, Radius, Slice, Stack
   
  Set BuildSphereMesh = mMesh
End Function

Public Function BuildRockMesh(Name As String) As TrueVision3D.TVMesh
Dim Mesh As TrueVision3D.TVMesh
Set Mesh = Scene.CreateMeshBuilder(Name)
  Mesh.Load3DsMesh "stonehenge\henge1.3Ds"
  Mesh.ScaleMesh 1, 1, 1
  Mesh.ComputeNormals
  Mesh.ComputeSphere
  Mesh.Optimize
  Mesh.SetLODVertexes 30
  Mesh.SetTexture GetTex("Stone")
  Mesh.SetVertexType TV_COLOR_VERTEX
  Set BuildRockMesh = Mesh
End Function
  
