Attribute VB_Name = "Trees"
Private mTrees  As TreeFactory
Private mTreeMaterialFactory As TrueVision3D.TVMaterialFactory

Public Sub InitalizeTrees()
  LoadTrees
End Sub

Public Sub DoTrees()
  mTrees.MoveLeaves tv.TickCount, 3, 200, True
End Sub
Private Sub LoadTrees()
  Dim i As Integer
  Set mTrees = New TreeFactory
  Set mTreeMaterialFactory = New TrueVision3D.TVMaterialFactory
  With mTreeMaterialFactory
    .CreateMaterial "TreeMaterial"
    .SetAmbient GetMat("TreeMaterial"), 0, 0, 0, 1
    .SetDiffuse GetMat("TreeMaterial"), 0.4, 0.4, 0, 1
    .SetEmissive GetMat("TreeMaterial"), 0.4, 0.4, 0, 1
  End With
  mTrees.InitTrees Scene, Landscape
  'RandomTrees
  SingleTree
End Sub

Private Sub SingleTree()
Dim i As Long
Dim j As Long
Dim Xpos As Single
Dim ZPos As Single
Dim Height As Single
'Create 86 trees
For j = 0 To 85
      'position them randomly
      Randomize
      Xpos = 700 + Rnd() * 1400
      Randomize
      ZPos = 300 + Rnd() * 2000
      Height = 25 + Rnd() * 100
      
      If Landscape.GetHeight(Xpos, ZPos) > 40 Then
        i = mTrees.AddTree(GetTex("tree1"), Xpos, Landscape.GetHeight(Xpos, ZPos), ZPos, _
        5, Height, 1, 10, 10, 1, 1)
        mTrees.TreeMesh.SetMaterial GetMat("TreeMaterial"), i + 0
        mTrees.AddLeaves GetTex("GreenLeaves"), 60, Height * 0.7, 2 + Rnd() * 3, TV_LEAVES_Y, i
      End If
Next
   'mTrees.AddLeaf GetTex("GreenLeaf"), 3, CInt(Rnd * 96), 1
   'mTrees.AddLeaf GetTex("GreenLeaf"), 5, CInt(Rnd * 6), 2
End Sub

